#
# Parameters for all makefiles of the laser program suite
# Christian Buth
# 04 May 2006
#


#
# Directories and programs
#

BASEDIR=$(HOME)/devel/fella/trunk
BINDIR=$(HOME)/local/bin
LIBDIR=$(HOME)/local/lib
MODULE=$(BASEDIR)/modules
VERSION=_1.3.0

hermsk=$(BASEDIR)/hermsk
oneel=$(BASEDIR)/oneel
mulph=$(BASEDIR)/mulph
misc=$(BASEDIR)/misc
dreyd=$(BASEDIR)/dreyd
giant=$(BASEDIR)/giant
alignmol=$(BASEDIR)/alignmol
lanczos=$(BASEDIR)/lanczos
twoph=$(BASEDIR)/twoph
pulseprop=$(BASEDIR)/pulseprop


#
# Variables
#

# General variables
make=make


# gfortran Optionen
#FC95=gfortran
#FC77=gfortran
#LK=gfortran
#F95OPT=-std=f95   -fdefault-real-8 -J$(MODULE) -I$(MODULE) -fbounds-check -Wall -Wunderflow
#F77OPT=-std=legacy -fdefault-real-8 -J$(MODULE) -I$(MODULE) -fbounds-check -Wall -Wunderflow
#lext=_gfor


# g95 options
FC95=g95
FC77=g95
LK=g95
#LKOPT=-static
LKOPT=
F95OPT=-r8 -fmod=$(MODULE) -Wall -Wline-truncation -ftrace=full -fbounds-check -Wobsolescent
F77OPT=-r8 -fmod=$(MODULE) -Wall -Wline-truncation -ftrace=full -fbounds-check
# #  -Wunused-parameter
lext=_g95v0.91


# ifort options
#FC95=ifort
#FC77=ifort
#LK=ifort
#LKOPT=-static -B$(MODULE)
#F95OPT=-g -check all -O0 -B$(MODULE) -I$(MODULE) -module $(MODULE)
#F77OPT=-g -check all -O0 -B$(MODULE) -I$(MODULE) -module $(MODULE)
#lext=_ifort


#
# Rules
#

%.o : %.F
	$(FC77) $(F77OPT) -c -o $@ $<


%.o : %.f90
	$(FC95) $(F95OPT) -c -o $@ $<


%.o : %.F90
	$(FC95) $(F95OPT) -c -o $@ $<
