!
! intcross --- numerically integrate using the trapezoidal rule
! Christian Buth
! 19 July 2006
!

      program intcross
      implicit none

!       real*8 x1, y1, x2, y2, sigma
      real*8 x1, y1, x2, y2, x3, y3, sigma, thresh

!       sigma = 0.0D0
!       read(*,*,end=10) x2, y2
!
!       do
!         read(*,*,end=10) x1, y1
!
!         ! Trapezoidal rule
!         sigma = sigma + abs(x2 - x1) * (y1 + y2) / 2.0D0
!
!         x2 = x1
!         y2 = y1
!       end do


      thresh = 10.0D10
      sigma = 0.0D0
      read(*,*,end=10) x3, y3

      do
        read(*,*,end=10) x2, y2
        read(*,*,end=10) x1, y1
        if (.not. (x1 > x2 .and. x2 > x3)) then
          stop 'x1 > x2 > x3'
        end if
        if (abs(((x1 + x3) / 2.0D0) - x2) > 1.0D-12) then
          stop '((x1 + x3) / 2.0D0) /= x2'
        end if

        ! Simpson's rule
        sigma = sigma + (x1 - x3) / 6.0D0 * (y1 + 4.0D0 * y2 + y3)

        ! Terminate when interval boundary reached
        if (x1 >= thresh) then
          go to 20
        end if

        x3 = x1 ; y3 = y1
      end do

 10   continue
      write (*,*) 'End of point mesh reached!!!!!'

 20   continue
      write (*,*) 'The integrated function is', sigma
      write (*,*)
      end program intcross
